
.publish:
  image: alpine
  script:
    - mkdir -p site
    - echo "Hello" > site/index.html
    - date >> site/index.html
    - echo -n "$CI_ENVIRONMENT_URL" > .environment-url
    - echo -n "$CI_JOB_ID" > .job-id

publish-for-mr-by-environment:
  extends: ['.publish']
  rules:
    - if: $CI_MERGE_REQUEST_IID
  environment:
    name: mr/$CI_MERGE_REQUEST_IID
    url: 'https://fpotter-gitlab.gitlab.io/-/sandbox/environments/-/jobs/${CI_JOB_ID}/artifacts/site/index.html'
  artifacts:
    paths:
      - site/

ublish-for-mr-by-environment-dynamic-url:
  extends: ['.publish']
  rules:
    - if: $CI_MERGE_REQUEST_IID
  variables:
    MY_PATH: 'sandbox/environments'
  environment:
    name: mrd/$CI_MERGE_REQUEST_IID
    url: 'https://fpotter-gitlab.gitlab.io/-/${MY_PATH}/-/jobs/${CI_JOB_ID}/artifacts/site/index.html'
  artifacts:
    paths:
      - site/

publish-by-expose-as:
  extends: ['.publish']
  artifacts:
    expose_as: 'site'
    paths:
      - site/


publish-for-testing:
  extends: ['.publish']
  environment:
    name: sha/$CI_COMMIT_SHA
    url: 'https://fpotter-gitlab.gitlab.io/-/sandbox/environments/-/jobs/${CI_JOB_ID}/artifacts/site/index.html'
  artifacts:
    paths:
      - site/
      - .environment-url
      - .job-id

test:
  needs: ['publish-for-testing']
  image: alpine
  script:
    - JOB_ID=$(cat .job-id)
    - apk add curl
    # - URL=$(cat .environment-url)
    # - URL="https://gitlab.com/fpotter-gitlab/sandbox/environments/-/jobs/artifacts/main/browse?job=publish-for-testing"
    # - URL="https://gitlab.com/api/v4/projects/53595399/jobs/artifacts/main/raw/site/index.html?job=publish-for-testing"
    # - 'curl -LIs --header "PRIVATE-TOKEN: $CI_JOB_TOKEN" "${URL}"'
    # - 'curl -Ls  --header "PRIVATE-TOKEN: $CI_JOB_TOKEN" "${URL}"'
    # - URL="https://gitlab.com/api/v4/projects/53595399/jobs/${JOB_ID}/artifacts/site/index.html?job_token=$CI_JOB_TOKEN"
    # - 'curl -LIs "${URL}"'
    # - 'curl -Ls  "${URL}"'
    # - URL="https://gitlab.com/api/v4/projects/53595399/jobs/artifacts/main/raw/site/index.html?job=publish-for-testing&job_token=$CI_JOB_TOKEN"
    # - URL="https://gitlab.com/api/v4/projects/53595399/jobs/artifacts/main/download?job=publish-for-testing&job_token=$CI_JOB_TOKEN"
    # - 'curl -LIs "${URL}"'
    - exit 1
  allow_failure: true
  environment:
    name: sha/$CI_COMMIT_SHA
    action: stop

workflow:
  rules:
    - if: >-
        $CI_PIPELINE_SOURCE == 'push' &&
        $CI_COMMIT_BEFORE_SHA == '0000000000000000000000000000000000000000'
      when: never
    - if: $CI_COMMIT_BRANCH && $CI_OPEN_MERGE_REQUESTS
      when: never
    - if: $CI_COMMIT_TAG
      when: never
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
      variables:
        PIPELINE_CACHE_POLICY: 'pull-push'
    - if: $CI_COMMIT_REF_NAME
      variables:
        PIPELINE_CACHE_POLICY: 'pull'
